using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Text;
using System.Drawing.Drawing2D;
using System.Drawing.Printing;
using System.Text;
using System.Windows.Forms;

namespace cprac
{
    public partial class frmMain : Form
    {
        //vZbg`
        string[] PresetList = new string[]{
            "EJ~ΉԊLwCxʋ󌎌܌ZORqlԎ\oXl[ΐԐ摁j|VcyNSؖ{ڗ͗јZ",
            "H_ȉĉƉ̉CGOpyԊۊDLA|ߌZ`vˌÌߌHLlsJˍ׍Z~sovЎHTtFHSVe}ؐDOg̑nrmʒX_d~ǓnԕĕkіFpjb",
            "Èψӈ@^jw׊JEKي݋Nq}{ƋȋǋNWyɌΌK`ՎMdgnwʎҎBEIKWZdh͏A\g_^[ȋSzőΑґYZkǒJS]sxo_gz{ߔ@MX\baiԕוʖRLV\rmtzlΗHa",
            "ĈȈ߈ʈ͈݈phʉ݉ۉBQeoXǊ֊ϊGI@c~ɌPRSa^i|ŌDqN؍ōލDE@QYUcmji؎jΏďۏƏܐbMȐÐȐϐܐߐIRqёBPuIT`kwŔMOs~єK[Wsvt{ʕӕϕ֕@]qEv{Ǘʗ֗ޗߗAVJ^",
            "ڈicqՉvt͉߉imzKZ`tvϋ֋Qǒkz\učЍȍ̍ۍݍߎG_^xu}tɎӎCqp؏DEŐӐѐڐݐKcfޑݑԒcfzKGƔCR\jƔŔU]nzwxҕٕەLhf\ȗA]ae",
            "وFfDgvtŊȊM^z΋،nhxȌČ@Fcg~|ύٍ\pˎ̎ڎ@AO]cknjmPtnwSTaiglɓW}͓F[]hqwxoǔӔ۔镠ÕЕKSY_͖XDc~՘N_",
            "ˈЈ׈ш̈ۈԈ܈ABCresuxzy{񉳉ˉ؉ىQŉɉЌCǉӉ҉FNUSYT_jksruldnx|Êʊ̊׊ъՊĊɊҊ͊ӊ܊FOQSPRXU\VY[]egilprsyu䋥ŋËҋۋՋًދ݋@JMOYs_b[fkuXgpce{}~ǌʌٌ͌֌یڌ݌EIb]BRUXSmP^rxvTQdiajyetwӍɍ͍ʍ֍Í΍ڍ܍|BCVSPb|fh{kŎ͎ΎώՎ׎֎َގߎݎMGLDVXP`[_aebfilmru{y}z@яǏˏ̏Џ׏ŏɏϏُڏՏʏBGJLhNÐOPUZafQTRkdnsvrwq䐎䐩Đː͐ǐɐՐАِސېHLJE@NTQUjd[eaiYbos{}K|rmÑđʑϑӑّבܑߑ֑ؑAEDIO_WQ[bedpvxst{~ޒĒ˒Вؒ@DEHRNOPYalfrnhz{|ēʓ˓ԓؓݓܓADEJSYZcektrpy|}Ȕʔ̔ϔД͔ɔ˔ؔՔܔޔڔCPYc`Llopqr}|~ǕȕΕՕ߉YܕFMAECOJDRZVW[b^`UaTXcdplnovxz|}~ŖƖΖϖӖՖҖԖٖ@BHIPTYUJZ^_fghnxqiw}˗×ƗЗϗחܗݗۗߗBFIYQLORdfgpr",
        };
        string BaseTitle;
        Bitmap backbuf;

        //~P
        float PaperWidth = 210f, PaperHeight = 297f;
        float MarginSize = 10.0f;
        float MarginBottom = 10.0f;

        int PNGWidth = 2100, PNGHeight = 2970;
        int curpage = 1;

        //`
        private void DrawCharMode(Graphics g,int page)
        {
            int Rows = (int)numCharRow.Value;
            int Cols = (int)numCharCol.Value;
            float size,MarginLeft,MarginTop;
            string strtarget = txtTarget.Text;

            int CellChars = (int)numCellPerChar.Value;
            int CellTrans = (int)numCellTrans.Value;

            float ml = ((int)hscLeft.Value - 1000) / 1000.0f;
            float mt = ((int)hscTop.Value - 1000) / 1000.0f;

            //TCYvZ
            size = Math.Min((PaperWidth - MarginSize * 2) / Cols, (PaperHeight - MarginSize * 2 - MarginBottom) / Rows);
            MarginLeft = (PaperWidth - size * Cols) / 2;
            MarginTop = (PaperHeight - size * Rows - MarginBottom) / 2;

            g.Clear(Color.White);
            g.ScaleTransform(g.VisibleClipBounds.Width / PaperWidth, g.VisibleClipBounds.Height / PaperHeight);

            Pen p = new Pen(Color.Black, 1);
            //c
            for (int i = 0; i <= Cols; i++)
                g.DrawLine(p, MarginLeft + size * i, MarginTop, MarginLeft + size * i, PaperHeight - MarginTop - MarginBottom);
            //
            for (int i = 0; i <= Rows; i++)
                g.DrawLine(p, MarginLeft, MarginTop + size * i, PaperWidth - MarginLeft, MarginTop + size * i);


            StringFormat sf;

            if (comboFont.Text != "" && CellChars > 0 && page > 0)
            {
                //cɂ
                sf = new StringFormat();
                sf.FormatFlags = StringFormatFlags.DirectionVertical;
                sf.Alignment = StringAlignment.Center;
                sf.LineAlignment = StringAlignment.Center;

                Font f = new Font(comboFont.Text, size * (int)hscSize.Value / 1000.0f);
                p = new Pen(Brushes.Black, 0.2f);
                p.DashStyle = DashStyle.Dash;

                //eZ̕
                for (int c = 0; c < Cols; c++)
                {
                    for (int r = 0; r < Rows; r++)
                    {
                        int id = (page - 1) * Rows * Cols + c * Rows + r;
                        if (id / CellChars >= strtarget.Length) continue;

                        //̃O[`
                        if (id % CellChars < CellTrans)
                        {
                            //g.MeasureString();
                            g.DrawString(strtarget.Substring((id / CellChars), 1), f, Brushes.Gray,
                                MarginLeft + size * (Cols - 1 - c + 0.5f + ml), MarginTop + size * (r + 0.5f + mt), sf);
                        }
                        //
                        g.DrawLine(p,MarginLeft + size * (Cols - 1 - c + 0.5f), MarginTop + size * r, 
                            MarginLeft + size * (Cols - 1 - c + 0.5f), MarginTop + size * (r + 1));
                        g.DrawLine(p, MarginLeft + size * (Cols - 1 - c), MarginTop + size * (r + 0.5f),
                            MarginLeft + size * (Cols - c), MarginTop + size * (r + 0.5f));

                    }
                }
                sf.Dispose();
                f.Dispose();
                p.Dispose();
            }

            //y[W\L
            sf = new StringFormat();
            sf.Alignment = StringAlignment.Center;
            sf.LineAlignment = StringAlignment.Center;
            g.DrawString(page.ToString() + " / " + trackPage.Maximum.ToString(), new Font("MS SVbN",5.0f),
                Brushes.Black, PaperWidth / 2, PaperHeight - MarginSize - MarginBottom/2, sf);

        }
        private void RefreshCellState()
        {
            //y[WČvZ
            int Cells = (int)numCharRow.Value * (int)numCharCol.Value;

            int numCell = (int)txtTarget.Text.Length * (int)numCellPerChar.Value;
            int numPages = (numCell + (Cells - 1)) / Cells;
            
            trackPage.Maximum = numPages;
            trackPage.Minimum = 1;
            trackPage_Scroll(null, null);
        }

        private void RefreshCellState(object sender, EventArgs e)
        {
            RefreshCellState();
        }

        public frmMain()
        {
            InitializeComponent();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            //obNobt@
            backbuf = new Bitmap(picPreview.ClientSize.Width, picPreview.ClientSize.Height);
            BaseTitle = this.Text;

            //tHgꗗo^
            foreach (FontFamily ff in new InstalledFontCollection().Families)
            {
                if (ff.IsStyleAvailable(FontStyle.Regular))
                        comboFont.Items.Add(ff.Name);
            }
            hsc_Scroll(null, null);
        }

        private void comboPreset_SelectedIndexChanged(object sender, EventArgs e)
        {
            //vZbg
            txtTarget.Text = PresetList[comboPreset.SelectedIndex];
        }

        private void txtTarget_TextChanged(object sender, EventArgs e)
        {
            RefreshCellState();
        }

        private void numCharCol_ValueChanged(object sender, EventArgs e)
        {
            RefreshCellState();
        }

        private void hsc_Scroll(object sender, ScrollEventArgs e)
        {
            float ms = (int)hscSize.Value / 1000.0f;
            lblSize.Text = "TCY:" + ms.ToString("p1");
            float ml = ((int)hscLeft.Value - 1000) / 1000.0f;
            lblLeft.Text = ":" + ml.ToString("p1");
            float mt = ((int)hscTop.Value - 1000) / 1000.0f;
            lblTop.Text = "c:" + mt.ToString("p1");
            RefreshCellState();
        }


        private void trackPage_Scroll(object sender, EventArgs e)
        {
            lblPage.Text = "y[W F" + trackPage.Value.ToString() + "/" + trackPage.Maximum.ToString();
            DrawCharMode(Graphics.FromImage(backbuf), trackPage.Value);
            picPreview.Invalidate();
        }

        private void picPreview_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            g.DrawImage(backbuf, 0, 0);
        }

        private void SaveBMP(bool save_all)
        {
            //摜Ƃĕۑ

            string prefix = (string)Microsoft.VisualBasic.Interaction.InputBox(
                "t@C̃vtBbNX͂Ă",
                "摜Ƃĕۑ", "cprac", -1,-1);
            if (prefix == "") return;

            for (int page = 1; page <= (int)trackPage.Maximum; page++)
            {
                if (!save_all && page != (int)trackPage.Value) continue;

                this.Text = "ۑF" + page.ToString() + "y[W";
                System.Windows.Forms.Application.DoEvents();


                Bitmap bm = new Bitmap(PNGWidth, PNGHeight);
                Graphics g = Graphics.FromImage(bm);
                g.Clear(Color.White);
                DrawCharMode(g, page);

                string filename = prefix + page.ToString("000") + ".png";
                bm.Save(filename, System.Drawing.Imaging.ImageFormat.Png);

                g.Dispose();
                bm.Dispose();
            }

            MessageBox.Show("t@C쐬܂B");
            this.Text = BaseTitle;


        }

        private void butSaveCur_Click(object sender, EventArgs e)
        {
            SaveBMP(false);
        }

        private void butSaveAll_Click(object sender, EventArgs e)
        {
            SaveBMP(true);
        }

        private void butPrint_Click(object sender, EventArgs e)
        {
            //
            if (trackPage.Maximum == 0) return;
            printDialog1.PrinterSettings.MinimumPage = 1;
            printDialog1.PrinterSettings.FromPage = 1;
            printDialog1.PrinterSettings.MaximumPage = (int)trackPage.Maximum;
            printDialog1.PrinterSettings.ToPage = (int)trackPage.Maximum;
            curpage = 1;

            if (printDialog1.ShowDialog() == DialogResult.OK)
                printDocument1.Print();

        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            if (e.PageSettings.PrinterSettings.PrintRange == PrintRange.SomePages &&
                curpage == 1)
                curpage = e.PageSettings.PrinterSettings.FromPage;

            DrawCharMode(e.Graphics, curpage);
            if (curpage >= (int)trackPage.Maximum ||
                (e.PageSettings.PrinterSettings.PrintRange ==
                System.Drawing.Printing.PrintRange.SomePages &&
                e.PageSettings.PrinterSettings.ToPage <= curpage))
            {
                if (--e.PageSettings.PrinterSettings.Copies > 0)
                {
                    e.HasMorePages = true;
                    curpage = 1;
                }
                else
                {
                    e.HasMorePages = false;
                }
                
            }
            else
            {
                e.HasMorePages = true;
                curpage++;
            }



        }

    }
}